## docker.io 19.03.8

=== components/cli/Makefile ===
#
# github.com/docker/cli
#
all: binary


_:=$(shell ./scripts/warn-outside-container $(MAKECMDGOALS))

.PHONY: clean
clean: ## remove build artifacts
	rm -rf ./build/* cli/winresources/rsrc_* ./man/man[1-9] docs/yaml/gen

.PHONY: test-unit
test-unit: ## run unit tests, to change the output format use: GOTESTSUM_FORMAT=(dots|short|standard-quiet|short-verbose|standard-verbose) make test-unit 
	gotestsum $(TESTFLAGS) -- $${TESTDIRS:-$(shell go list ./... | grep -vE '/vendor/|/e2e/')}

.PHONY: test
test: test-unit ## run tests

.PHONY: test-coverage
test-coverage: ## run test coverage
	gotestsum -- -coverprofile=coverage.txt $(shell go list ./... | grep -vE '/vendor/|/e2e/')

.PHONY: fmt
fmt:
	go list -f {{.Dir}} ./... | xargs gofmt -w -s -d

.PHONY: lint
lint: ## run all the lint tools
	gometalinter --config gometalinter.json ./...

.PHONY: binary
binary: ## build executable for Linux
	@echo "WARNING: binary creates a Linux executable. Use cross for macOS or Windows."
	./scripts/build/binary

.PHONY: plugins
plugins: ## build example CLI plugins
	./scripts/build/plugins

.PHONY: cross
cross: ## build executable for macOS and Windows
	./scripts/build/cross

.PHONY: binary-windows
binary-windows: ## build executable for Windows
	./scripts/build/windows

.PHONY: plugins-windows
plugins-windows: ## build example CLI plugins for Windows
	./scripts/build/plugins-windows

.PHONY: binary-osx
binary-osx: ## build executable for macOS
	./scripts/build/osx

.PHONY: plugins-osx
plugins-osx: ## build example CLI plugins for macOS
	./scripts/build/plugins-osx

.PHONY: dynbinary
dynbinary: ## build dynamically linked binary
	./scripts/build/dynbinary

vendor: vendor.conf ## check that vendor matches vendor.conf
	rm -rf vendor
	bash -c 'vndr |& grep -v -i clone'
	scripts/validate/check-git-diff vendor

.PHONY: authors
authors: ## generate AUTHORS file from git history
	scripts/docs/generate-authors.sh

.PHONY: manpages
manpages: ## generate man pages from go source and markdown
	scripts/docs/generate-man.sh

.PHONY: yamldocs
yamldocs: ## generate documentation YAML files consumed by docs repo
	scripts/docs/generate-yaml.sh

.PHONY: shellcheck
shellcheck: ## run shellcheck validation
	scripts/validate/shellcheck

.PHONY: help
help: ## print this help
	@awk 'BEGIN {FS = ":.*?## "} /^[a-zA-Z0-9_-]+:.*?## / {gsub("\\\\n",sprintf("\n%22c",""), $$2);printf "\033[36m%-20s\033[0m %s\n", $$1, $$2}' $(MAKEFILE_LIST)


cli/compose/schema/bindata.go: cli/compose/schema/data/*.json
	go generate github.com/docker/cli/cli/compose/schema

compose-jsonschema: cli/compose/schema/bindata.go
	scripts/validate/check-git-diff cli/compose/schema/bindata.go

.PHONY: ci-validate
ci-validate:
	time make -B vendor
	time make -B compose-jsonschema
	time make manpages
	time make yamldocs

=== debian/changelog ===
docker.io (19.03.8-0ubuntu1) focal; urgency=medium

  * Update to 19.03.8 upstream release (LP: #1867068)
    - Improve mitigation for CVE-2019-14271 for some nscd configuration.

 -- Tianon Gravi <tianon@debian.org>  Wed, 11 Mar 2020 15:48:33 -0700

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
           Tianon Gravi <tianon@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: bash-completion,
               ca-certificates,
               cmake,
               debconf (>= 0.5),
               debhelper (>= 9.20160709~),
               dh-apparmor,
               dh-exec,
               git,
               golang-any (>= 2:1.12~),
               libapparmor-dev,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libdevmapper-dev (>= 2:1.02.68~),
               libltdl-dev,
               libseccomp-dev,
               libsystemd-dev (>= 209~),
               pkg-config,
               procps,
               tzdata
Standards-Version: 3.9.8
Homepage: https://www.docker.com/community-edition
Vcs-Git: https://anonscm.debian.org/git/docker/docker.io.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: adduser,
         containerd (>= 1.2.6-0ubuntu1~),
         iptables,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates,
            cgroupfs-mount | cgroup-lite,
            git,
            pigz,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Replaces: docker (<< 1.5~)
Breaks: docker (<< 1.5~)
Suggests: aufs-tools,
          btrfs-progs,
          debootstrap,
          docker-doc,
          rinse,
          zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}, golang-github-docker-docker-credential-helpers-dev
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
Provides: golang-docker-dev
Description: Externally reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Priority: optional
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export VERSION := $(shell cat VERSION)

export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(VERSION))

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor seccomp selinux

ifneq (,$(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	NUMJOBS := $(patsubst parallel=%, %, $(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j '$(NUMJOBS)'
endif

override_dh_gencontrol:
	# if we're on Ubuntu, we need to Recommends: apparmor
	echo 'apparmor:Recommends=$(shell dpkg-vendor --is Ubuntu && echo apparmor)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker.io.substvars
	dh_gencontrol

override_dh_auto_configure:
	# set up GOPATH symlink farm
	# libnetwork
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/libnetwork' '$(OUR_GOPATH)/src/github.com/docker/libnetwork'
	# cli
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/components/cli' '$(OUR_GOPATH)/src/github.com/docker/cli'
	# engine
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/components/engine' '$(OUR_GOPATH)/src/github.com/docker/docker'

_require-gitcommit:
	@bash -c '{ [ "$$DOCKER_GITCOMMIT" ]; } || { echo; echo "error: missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits"; echo; exit 2; } >&2'

override_dh_auto_build: _build-tini _build-proxy _build-cli _build-manpages _build-engine
	@#

# several "supporting binaries" need to be built and installed
# (https://github.com/docker/docker-ce/tree/v19.03.6/components/engine/hack/dockerfile/install)

_build-tini: # (docker-init)
	mkdir -p tini/build
	cd tini/build \
		&& cmake .. \
		&& make tini-static

_build-proxy: # (from libnetwork)
	go build -o libnetwork/docker-proxy github.com/docker/libnetwork/cmd/proxy

_build-cli: _require-gitcommit
	DISABLE_WARN_OUTSIDE_CONTAINER=1 \
		make -C components/cli \
			LDFLAGS='' \
			VERSION='$(VERSION)' \
			GITCOMMIT='$(DOCKER_GITCOMMIT)' \
			dynbinary

# https://github.com/docker/docker-ce/blob/v19.03.6/components/cli/scripts/docs/generate-man.sh
# (replacing hard-coded "/tmp/gen-manpages" with "debian/tmp/gen-manpages")
_build-manpages:
	cd '$(OUR_GOPATH)/src/github.com/docker/cli' \
		&& export PATH='$(OUR_GOPATH)/bin':"$$PATH" \
		&& sed 's!/tmp/gen-manpages!$(CURDIR)/debian/tmp/gen-manpages!g' scripts/docs/generate-man.sh \
			| bash

_build-engine: _require-gitcommit
	cd components/engine \
		&& PRODUCT=docker ./hack/make.sh dynbinary

# basic smoke test to ensure binaries built successfully
# (especially since their actual tests are *really* involved)
override_dh_auto_test:
	# tini
	./tini/build/tini-static --version
	# cli
	./components/cli/build/docker --version
	# engine
	./components/engine/bundles/dynbinary-daemon/dockerd --version

override_dh_strip:
	# Go has lots of problems with stripping, so just don't

override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be

# "--no-start" because we have a debconf prompt to determine whether to restart during upgrades
# (which means we get to handle both "start" and "stop" ourselves too)
override_dh_installinit:
	dh_installinit --name=docker --no-start

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80

override_dh_install:
	dh_install
	dh_apparmor --profile-name=docker.io -pdocker.io

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_clean:
	@# stop debhelper from doing "make clean"

%:
	dh $@ --with=bash-completion,systemd

## docker.io 19.03.12+dfsg1

=== debian/changelog ===
docker.io (19.03.12+dfsg1-3) unstable; urgency=medium

  * Add patch to disable TestRunLabel 

 -- Arnaud Rebillout <elboulangero@gmail.com>  Mon, 13 Jul 2020 13:49:29 +0700

docker.io (19.03.12+dfsg1-2) unstable; urgency=medium

  * Add upstream patch to silence systemd warning (/var/run → /run)

 -- Arnaud Rebillout <elboulangero@gmail.com>  Mon, 13 Jul 2020 08:56:49 +0700

docker.io (19.03.12+dfsg1-1) unstable; urgency=medium

  * Rework dockerfile, add a helper to use docker to build the package
  * d/copyright: Indent and sort a few things
  * d/rules: Remove old comments
  * d/control: Update my email address in the maintainer field
  * New upstream release [19.03.12].
  * d/tests/basic-smoke: Debootstrap from buster (Closes: #946313)
  * d/tests/basic-smoke: Use systemctl to start/stop docker
  * d/tests/basic-smoke: More lines to the tail command
  * d/tests/basic-smoke: Use deb.debian.org to debootstrap
  * d/tests/basic-smoke: Style nitpicks
  * Install dockerd-rootless.sh in usr/share/docker.io/contrib (Closes: #964071)
  * d/rules: Silence lintian warnings regarding executable text files
  * docker-dev: Install containerd -dev files from build directory
  * docker-dev: Re-order the file d/...-dev.install

 -- Arnaud Rebillout <elboulangero@gmail.com>  Fri, 03 Jul 2020 12:09:20 +0700

docker.io (19.03.11+dfsg1-1) unstable; urgency=medium

  * New upstream release [19.03.11].
  * Update Files-Excluded list (ie. exclude archive vendoring)
  * Update and drop patches
  * Use gotest.tools import path in docker cli (without v3)

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Fri, 19 Jun 2020 13:41:28 +0700

docker.io (19.03.7+dfsg1-3) unstable; urgency=medium

  * dev: provide "rootless" component (Closes: #960827).

 -- Dmitry Smirnov <onlyjob@debian.org>  Sun, 17 May 2020 17:07:15 +1000

docker.io (19.03.7+dfsg1-2) unstable; urgency=medium

  [ Dmitry Smirnov ]
  * Added missing-pre-depends. Thanks, Lintian.
  * debian/TODO.Debian --> debian/TODO.
  * L:Override "field-too-long Built-Using" on binary package also.

  [ Arnaud Rebillout ]
  * d/clean: Remove lines that are obsolete.
  * d/clean: Update for doc files.
  * Add upstream patch to fix panic in libnetwork resolver (Closes: #958312).
  * Add patch to skip flaky signal tests.

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Tue, 21 Apr 2020 13:32:19 +0700

docker.io (19.03.7+dfsg1-1) unstable; urgency=medium

  * New upstream release [19.03.7].
  * Drop test--disable-containerizedengine-update-test.patch.
  * Unvendor vbom.ml/util and grpc-ecosystem/grpc-opentracing
    (now packaged in Debian).

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Tue, 14 Apr 2020 13:17:23 +0700

docker.io (19.03.6+dfsg1-4) unstable; urgency=medium

  * Do not use bundled "golang-github-stevvooe-ttrpc-dev" (Closes: #956502).

 -- Dmitry Smirnov <onlyjob@debian.org>  Mon, 13 Apr 2020 22:19:11 +1000

docker.io (19.03.6+dfsg1-3) unstable; urgency=medium

  * New patch to disable failing test (Closes: #954727).
  * New upstream patch to fix FTBFS with xeipuuv-gojsonschema (>= 1.2.0~).
  * Lintian-override for "field-too-long Built-Using".
  * DH to version 12.
  * Build-Depends:
    - golang-github-tinylib-msgp-dev
    + golang-github-xeipuuv-gojsonschema-dev (>= 1.2.0~)

 -- Dmitry Smirnov <onlyjob@debian.org>  Sat, 11 Apr 2020 18:57:29 +1000

docker.io (19.03.6+dfsg1-2) unstable; urgency=medium

  * New upstream patch to fix FTBFS in "libnetwork" (Closes: #952311).
  * Build-Depends:
    = golang-github-miekg-dns-dev (>= 1.1.26~)

 -- Dmitry Smirnov <onlyjob@debian.org>  Wed, 26 Feb 2020 11:20:11 +1100

docker.io (19.03.6+dfsg1-1) unstable; urgency=medium

  * New upstream release [19.03.6].
  * Drop patches applied upstream.
  * Vendor containerd-cgroups.
  * d/copyright: Remove unused snippets.

 -- Arnaud Rebillout <arnaud.rebillout@collabora.com>  Wed, 19 Feb 2020 13:52:28 +0700

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Standards-Version: 4.4.1
Maintainer: Arnaud Rebillout <elboulangero@gmail.com>
Uploaders: Dmitry Smirnov <onlyjob@debian.org>
          ,Tim Potter <tpot@hpe.com>
          ,Tianon Gravi <tianon@debian.org>
          ,Paul Tagliamonte <paultag@debian.org>
#Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: debhelper-compat (= 12) ,dh-exec ,dh-golang (>= 1.14~)
    ,bash-completion
    ,ca-certificates
    ,git
    ,golang-any (>= 2:1.10~)
    ,go-md2man (>= 1.0.3~)
    ,gogoprotobuf, libprotobuf-dev
    ,golang-dbus-dev (>= 5.0.2~)
    ,golang-etcd-server-dev
    ,golang-github-appc-cni-dev (>= 0.7.1~)
      ,golang-github-containernetworking-plugins-dev
    ,golang-github-armon-go-metrics-dev
    ,golang-github-asaskevich-govalidator-dev
    ,golang-github-aws-aws-sdk-go-dev
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-bshuster-repo-logrus-logstash-hook-dev
    ,golang-github-bsphere-le-go-dev
    ,golang-github-burntsushi-toml-dev
    ,golang-github-cloudflare-cfssl-dev
    ,golang-github-codegangsta-cli-dev
    ,golang-github-containerd-btrfs-dev (>= 0.0~git20180306~)
#    ,golang-github-containerd-cgroups-dev
    ,golang-github-containerd-console-dev
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-containerd-fifo-dev
    ,golang-github-containerd-go-cni-dev (>= 0.0~git20190904~)
    ,golang-github-containerd-go-runc-dev
    ,golang-github-containerd-typeurl-dev
    ,golang-github-coreos-bbolt-dev (>= 1.3.1-coreos.5-3~)
    ,golang-github-coreos-go-systemd-dev (>= 20~)
    ,golang-github-creack-pty-dev
    ,golang-github-davecgh-go-spew-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-denverdino-aliyungo-dev
    ,golang-github-dgrijalva-jwt-go-dev (>= 3.2.0~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-dev
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-docker-libtrust-dev
    ,golang-github-docker-notary-dev (>= 0.6.1~) | golang-github-theupdateframework-notary-dev
    ,golang-github-docker-spdystream-dev
    ,golang-github-emicklei-go-restful-dev
    ,golang-github-evanphx-json-patch-dev (>= 4.1.0~)
    ,golang-github-fernet-fernet-go-dev
    ,golang-github-fluent-fluent-logger-golang-dev (>= 1.3.0~)
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-garyburd-redigo-dev
    ,golang-github-gofrs-flock-dev
    ,golang-github-gogo-googleapis-dev
    ,golang-github-googleapis-gax-go-dev
    ,golang-github-googleapis-gnostic-dev
    ,golang-github-google-go-cmp-dev (>= 0.2.0~)
    ,golang-github-google-gofuzz-dev
    ,golang-github-google-shlex-dev
    ,golang-github-google-uuid-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-gotestyourself-gotest.tools-dev
    ,golang-github-graylog2-go-gelf-dev (>= 0.0+git20191017~)
    ,golang-github-grpc-ecosystem-go-grpc-prometheus-dev
#   ,golang-github-grpc-ecosystem-grpc-gateway-dev
    ,golang-github-grpc-ecosystem-grpc-opentracing-dev
    ,golang-github-hashicorp-go-version-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-imdario-mergo-dev (>= 0.3.3~)
    ,golang-github-json-iterator-go-dev (>= 1.1.4~)
    ,golang-github-mattn-go-shellwords-dev
    ,golang-github-mattn-go-sqlite3-dev
    ,golang-github-miekg-dns-dev (>= 1.1.26~)
    ,golang-github-miekg-pkcs11-dev
    ,golang-github-mitchellh-hashstructure-dev
#   ,golang-github-modern-go-concurrent-dev
    ,golang-github-modern-go-reflect2-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-mrunalp-fileutils-dev
    ,golang-github-ncw-swift-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.3.0~)
    ,golang-github-opencontainers-specs-dev (>= 1.0.1~)
    ,golang-github-opentracing-contrib-go-stdlib-dev
    ,golang-github-opentracing-opentracing-go-dev
    ,golang-github-philhofer-fwd-dev
    ,golang-github-pmezard-go-difflib-dev
    ,golang-github-prometheus-client-golang-dev (>= 0.9.0~)
    ,golang-github-racksec-srslog-dev
    ,golang-github-rcrowley-go-metrics-dev
    ,golang-github-samuel-go-zookeeper-dev
    ,golang-github-satori-go.uuid-dev
    ,golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~)
    ,golang-github-shopify-logrus-bugsnag-dev
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
#    ,golang-github-spf13-cobra-dev (>= 0.0.2~)
#    ,golang-github-spf13-pflag-dev
    ,golang-github-stevvooe-ttrpc-dev
    ,golang-github-tchap-go-patricia-dev
    ,golang-github-tonistiigi-fifo-dev
    ,golang-github-ugorji-go-codec-dev
    ,golang-github-urfave-cli-dev (>= 1.20.0~)
    ,golang-github-vbatts-tar-split-dev (>= 0.11.1~)
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev (>= 0.0~git20170707~)
    ,golang-github-xeipuuv-gojsonschema-dev (>= 1.2.0~)
#   ,golang-glog-dev
    ,golang-gocapability-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-oauth2-google-dev | golang-golang-x-oauth2-dev
    ,golang-golang-x-time-dev
    ,golang-google-api-dev
    ,golang-google-cloud-dev
    ,golang-google-grpc-dev
    ,golang-gopkg-check.v1-dev
    ,golang-gopkg-inf.v0-dev
    ,golang-goprotobuf-dev (>= 0.0~git20151207~)
    ,golang-go-zfs-dev
    ,golang-protobuf-extensions-dev
    ,golang-vbom-util-dev
    ,gotestsum
    ,libapparmor-dev
    ,libbtrfs-dev | btrfs-progs (<< 4.16.1~)
    ,libdevmapper-dev
    ,pkg-config
    ,procps
    ,tzdata
Homepage: https://mobyproject.org
Vcs-Browser: https://salsa.debian.org/docker-team/docker
Vcs-Git: https://salsa.debian.org/docker-team/docker.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: linux-any
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends} ,${perl:Depends} ,${shlibs:Depends}
    ,adduser
    ,iptables
    ,lsb-base
    ,runc (>= 1.0.0~rc8~)
    ,tini
Recommends: ${apparmor:Recommends}
    ,ca-certificates
    ,cgroupfs-mount
    ,git
    ,needrestart (>= 3.1~)
    ,xz-utils
Replaces: docker (<< 1.5~)
    ,docker-containerd
    ,docker-runc
    ,golang-libnetwork
Breaks: docker (<< 1.5~)
    ,docker-containerd
    ,docker-runc
    ,golang-libnetwork
Conflicts: docker-containerd
    ,docker-runc
    ,golang-libnetwork
## Docker's vendor packages:
    ,docker-ce
    ,docker-ce-cli
    ,containerd.io
Suggests: docker-doc
    ,aufs-tools
    ,btrfs-progs
    ,debootstrap
    ,e2fsprogs
    ,rinse
    ,xfsprogs
    ,zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: ${misc:Depends}
    ,golang-github-azure-go-ansiterm-dev
    ,golang-github-containerd-continuity-dev (>= 0.0~git20190426~)
    ,golang-github-docker-distribution-dev (>= 2.7.1~)
    ,golang-github-docker-docker-credential-helpers-dev (>= 0.6.1~)
    ,golang-github-docker-go-connections-dev (>= 0.4.0~)
    ,golang-github-docker-go-metrics-dev
    ,golang-github-docker-go-units-dev (>= 0.4.0~)
    ,golang-github-docker-libkv-dev
    ,golang-github-fsnotify-fsnotify-dev
    ,golang-github-gorilla-mux-dev (>= 1.7.1~)
    ,golang-github-mattn-go-shellwords-dev
    ,golang-github-morikuni-aec-dev
    ,golang-github-opencontainers-go-digest-dev
    ,golang-github-opencontainers-image-spec-dev (>= 1.0.1~)
    ,golang-github-opencontainers-runc-dev (>= 1.0.0~rc8~)
    ,golang-github-opencontainers-selinux-dev (>= 1.3.0~)
    ,golang-github-pkg-errors-dev
    ,golang-github-seccomp-libseccomp-golang-dev (>= 0.9.1~)
    ,golang-github-sirupsen-logrus-dev (>= 1.0.2~)
    ,golang-github-stretchr-testify-dev
    ,golang-github-tchap-go-patricia-dev
    ,golang-golang-x-net-dev
    ,golang-golang-x-sys-dev (>= 0.0~git20190726~)
    ,golang-google-grpc-dev
    ,golang-gopkg-check.v1-dev
# libnetwork:
    ,golang-dbus-dev (>= 3~)
    ,golang-github-burntsushi-toml-dev
    ,golang-github-deckarep-golang-set-dev
    ,golang-github-docker-go-events-dev
    ,golang-github-gogo-protobuf-dev
    ,golang-github-hashicorp-memberlist-dev (>= 0.1.0~)
    ,golang-github-hashicorp-serf-dev
    ,golang-github-ishidawataru-sctp-dev
    ,golang-github-vishvananda-netlink-dev (>= 1.0.0~)
    ,golang-github-vishvananda-netns-dev
# containerd
    ,golang-github-appc-cni-dev (>= 0.7.1~)
      ,golang-github-containernetworking-plugins-dev
    ,golang-github-containerd-fifo-dev
    ,golang-github-tonistiigi-fifo-dev
# moby/buildkit/session
    ,golang-github-opentracing-opentracing-go-dev
Replaces: golang-github-containerd-containerd-dev
    ,golang-github-docker-libnetwork-dev
Breaks: golang-github-containerd-containerd-dev
    ,golang-github-docker-libnetwork-dev
Provides: golang-github-containerd-containerd-dev
    ,golang-github-docker-libnetwork-dev
Description: reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

#Package: golang-github-opencontainers-docker-runc-dev
#Section: oldlibs
#Architecture: all
#Depends: ${misc:Depends}
#    ,golang-github-opencontainers-runc-dev (>= 1.0.0~)
#Description: Open Container Project - development files (Docker's version)
# This is a transitional package to ease upgrades to the
# "golang-github-opencontainers-runc-dev" package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export HOME=$(CURDIR)/debian/tmp

#export DH_GOLANG_BUILDPKG := github.com/docker/docker github.com/docker/cli
export DH_GOLANG_GO_GENERATE := 1
export DH_GOLANG_INSTALL_ALL := 1
export DH_GOLANG_INSTALL_EXTRA := testdata/
export DH_GOLANG_EXCLUDES := \
    integration-cli \
    vendor

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)

export DOCKER_VERSION := $(shell cat VERSION)
export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(DOCKER_VERSION))
ifndef DOCKER_GITCOMMIT
  $(error Missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits)
endif

export BUILDTIME := $(shell dpkg-parsechangelog -SDate)

# have "make.sh" keep "bundle/$(DOCKER_VERSION)" around between runs (we clean it up appropriately ourselves)
export KEEPBUNDLE := 1

## AppArmor can be optionally used in Debian and is there by default in Ubuntu,
## so we need support for it compiled into our binary same story with SELinux.
export DOCKER_BUILDTAGS := apparmor seccomp selinux ambient

APPARMOR_RECOMMENDS := $(shell dpkg-vendor --is Ubuntu && echo apparmor)
BUILT_LIBC := $(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)

%:
	dh $@ --buildsystem=golang --with=bash-completion,golang --builddirectory=.gopath

override_dh_clean:
	dh_clean
	$(RM) -v -r autogen bundles man/man*/
#	-find . -type f -name '*.pb.go' -delete -printf 'removed %p\n'            ## delete generated .pb.go files
	## Remove Files-Excluded (when built from checkout or non-DFSG tarball):
	$(RM) -rv `perl -0nE 'say grep { $$_=q{ */}.$$_ } split(/\s+/,$$1) if m{^Files\-Excluded:\s*(.*?)(?:\n\n|^Files|^Comment:)}sm;' debian/copyright`
	-find */vendor -mindepth 1 -type d -empty -delete -printf 'removed %p\n'

override_dh_auto_configure:
## dh_auto_configure symlinks dirs from "/usr/share/gocode/src" into
## $(OUR_GOPATH) unless folders already exist there in which case files
## are copied. Pre-making directories allows us to use debhelper to
## create proper GOPATH source tree yet have certain directories writable
## even if they are provided by already installed package.
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/cli
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/docker
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/libnetwork
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/swarmkit
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/distribution
	mkdir -pv $(OUR_GOPATH)/src/github.com/docker/go-events
	mkdir -pv $(OUR_GOPATH)/src/github.com/containerd/containerd

## Prepare builddirectory but throw away sourcedirectory.
	DH_GOPKG="__IGNORE__" dh_auto_configure

## Each package must be removed from working tree first, in case some
## of the packages that we are going to build are already installed.
## This is also useful for building in unclean environment.
##
## This is _necessary_ to avoid merging packages that we build with
## pre-installed packages. See #827226 for details.
## Debhelper knows only about "main" DH_GOPKG package but we build several
## and we have to ensure that build tree is properly prepared.
	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/cli
	cp -ra  cli           $(OUR_GOPATH)/src/github.com/docker/cli

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/docker
	cp -ra  engine        $(OUR_GOPATH)/src/github.com/docker/docker

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/libnetwork
	cp -ra  libnetwork    $(OUR_GOPATH)/src/github.com/docker/libnetwork

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/swarmkit
	cp -ra  swarmkit      $(OUR_GOPATH)/src/github.com/docker/swarmkit

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/distribution
	cp -ra  distribution  $(OUR_GOPATH)/src/github.com/docker/distribution

	$(RM) -r              $(OUR_GOPATH)/src/github.com/docker/go-events
	cp -ra  go-events     $(OUR_GOPATH)/src/github.com/docker/go-events

	$(RM) -r              $(OUR_GOPATH)/src/github.com/containerd/containerd
	cp -ra  containerd    $(OUR_GOPATH)/src/github.com/containerd/containerd

## Patch docker cli to use gotest.tools in place of gotest.tools/v3.
	find $(OUR_GOPATH)/src/github.com/docker/cli -name '*.go' | xargs sed -i 's;gotest.tools/v3;gotest.tools;'

## Remove executable bit on text files in containerd. Needed to silence Lintian
## warnings, until we reach containerd 1.4.0.
## Ref: https://github.com/containerd/containerd/commit/773adf7
	chmod -x $(OUR_GOPATH)/src/github.com/containerd/containerd/api/*.txt

## Remove executable bit on text files in docker engine. Needed to silence
## Lintian warnings, until we reach the next stable branch of docker.
## Ref: https://github.com/moby/moby/commit/667c87e
	chmod -x $(OUR_GOPATH)/src/github.com/docker/docker/profiles/seccomp/default.json \
	         $(OUR_GOPATH)/src/github.com/docker/docker/profiles/seccomp/fixtures/example.json

override_dh_auto_build-indep:
	# noop

override_dh_auto_build-arch:
## Order is important:

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/distribution"    dh_auto_build -v

	DH_GOPKG="github.com/docker/libnetwork"                dh_auto_build -v

##	## FIXME: DH_GOLANG_BUILDPKG --> DH_GOPKG
	DH_GOLANG_BUILDPKG="github.com/docker/swarmkit"        dh_auto_build -v

	export DH_GOPKG="github.com/containerd/containerd" ;\
        export REV="`grep $${DH_GOPKG} engine/vendor.conf | head -1 | awk '{print $$2}'`" ;\
        dh_auto_build -v -- -tags "$(DOCKER_BUILDTAGS)" \
          -ldflags "-X $${DH_GOPKG}/version.Version=$(DOCKER_VERSION) -X $${DH_GOPKG}/version.Revision=$${REV}"

	DH_GOPKG="github.com/docker/go-events"                 dh_auto_build -v
	
##	build ("cd" first to ensure we build from within GOPATH)
	cd '$(OUR_GOPATH)/src/github.com/docker/docker' \
        && VERSION=$(DOCKER_VERSION) ./hack/make.sh dynbinary
	
	cd '$(OUR_GOPATH)/src/github.com/docker/cli' \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 LDFLAGS='' \
           $(MAKE) VERSION=$(DOCKER_VERSION) GITCOMMIT=$(DOCKER_GITCOMMIT) dynbinary manpages
	
#	# compile man pages
#	./man/md2man-all.sh -q

override_dh_auto_test-indep:
	DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
        dh_auto_test -v --max-parallel=4 -- -short

override_dh_auto_test-arch:
###     [[[ DO NOT DISABLE TESTS ]]]  [[[ DO *NOT* DISABLE TESTS ]]]
	DH_GOLANG_EXCLUDES="integration-cli integration test/integration" \
        dh_auto_test -v --max-parallel=4 -- -short
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))

	## Test engine:
	cd $(OUR_GOPATH)/src/github.com/docker/docker \
        && TESTFLAGS='-test.short' ./hack/test/unit

	## Test CLI:
	cd $(OUR_GOPATH)/src/github.com/docker/cli \
        && DISABLE_WARN_OUTSIDE_CONTAINER=1 $(MAKE) test-unit

	.gopath/bin/containerd -version
endif

override_dh_install:
	## Do not install extra license files:
	dh_install -XLICENSE

override_dh_auto_install:
	## skip dh_auto_install to stop dh_golang trying to copy bits
	## for /usr/share/gocode (we use dh_install/dh-exec for that)

override_dh_installinit:
	dh_installinit -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installsystemd:
	dh_installsystemd -v --name=docker --no-stop-on-upgrade --no-restart-after-upgrade

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev -v --name=docker --priority=z80

override_dh_gencontrol:
	echo 'apparmor:Recommends=$(APPARMOR_RECOMMENDS)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(BUILT_LIBC)' >> debian/docker.io.substvars
	dh_gencontrol

=== debian/watch ===
# uscan(1) configuration file.
version=4

opts="\
pgpmode=none,\
repacksuffix=+dfsg1,\
repack,compression=xz,\
uversionmangle=s{\-ce}{};s{(\d)[\-]?((rc|beta)\d*)$}{$1~$2},\
dversionmangle=s{[+~](dfsg|ds)\d*}{},\
" https://uscan.tianon.xyz/github.com/docker/docker-ce \
  .*/archive/v(\d\S*)\.tar\.gz debian ./debian/get-orig-source.sh

# /(releases|tags) paginates too soon on github.com
# so we lose historical versions too early for tianon's taste.
# https://github.com/docker/docker/releases

## docker.io 19.03.13

=== debian/changelog ===
docker.io (19.03.13-0ubuntu3) groovy; urgency=medium

  * SECURITY UPDATE: Sensitive information disclosure
    - debian/patches/CVE-2020-15157.patch: Improve fetch function.
    - CVE-2020-15157

 -- Paulo Flabiano Smorigo <pfsmorigo@canonical.com>  Wed, 14 Oct 2020 13:25:32 +0000

docker.io (19.03.13-0ubuntu2) groovy; urgency=medium

  [ Tianon Gravi ]
  * Backport https://github.com/moby/moby/pull/41518 to handle newer AppArmor

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Fri, 09 Oct 2020 08:28:02 +1300

docker.io (19.03.13-0ubuntu1) groovy; urgency=medium

  [ Tianon Gravi ]
  * Update to 19.03.13 upstream release
  * Build against Go 1.13 (per upstream)
  * Use dh-golang to generate appropriate Built-Using

 -- Michael Hudson-Doyle <michael.hudson@ubuntu.com>  Thu, 08 Oct 2020 10:43:13 +1300

docker.io (19.03.11-0ubuntu1) groovy; urgency=medium

  * Update to 19.03.11 upstream release (CVE-2020-13401, LP: #1881679)
  * Apply wrap-and-sort
  * Move cgroupfs-mount to Suggests
    (esp. on Ubuntu where systemd is canonical)

 -- Tianon Gravi <tianon@debian.org>  Mon, 01 Jun 2020 15:14:15 -0700

docker.io (19.03.8-0ubuntu4) groovy; urgency=medium

  * Provide "image" and "oci" components in golang dev package,
    mirroring Debian to address libpod FTBFS

 -- Reinhard Tartler <siretart@tauware.de>  Sat, 30 May 2020 11:56:59 -0400

docker.io (19.03.8-0ubuntu3) groovy; urgency=medium

  * Provide the rootless component in golang dev package, mirroring Debian
    (addresses nomad FTBFS).

 -- Logan Rosen <logan@ubuntu.com>  Tue, 26 May 2020 21:06:20 -0400

docker.io (19.03.8-0ubuntu2) groovy; urgency=medium

  [ Jean-Baptiste Lallement ]
  [ Didier Roche ]
  * Fix use with ZFS on root:
    - docker creates one dataset for any layer of containers that were
      created. Create now a <pool>/var/lib/docker for creating them in
      the persistent namespace and migrate existing one here.
    - purge the automated historic that was created.
    The migration only impacts the ubuntu desktop installation with
    experimental ZFS on root, and we have thus to stop and start the daemon
    to migrate data. (LP: #1879473)

 -- Didier Roche <didrocks@ubuntu.com>  Tue, 19 May 2020 11:01:22 +0200

=== debian/control ===
Source: docker.io
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Paul Tagliamonte <paultag@debian.org>
Uploaders: Docker Packaging Team <docker-maint@lists.alioth.debian.org>,
           Tianon Gravi <tianon@debian.org>
Build-Conflicts: golang-github-docker-docker-dev
Build-Depends: bash-completion,
               ca-certificates,
               cmake,
               debconf (>= 0.5),
               debhelper (>= 9.20160709~),
               dh-apparmor,
               dh-exec,
               dh-golang,
               git,
               golang-1.13-go,
               libapparmor-dev,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libdevmapper-dev (>= 2:1.02.68~),
               libltdl-dev,
               libseccomp-dev,
               libsystemd-dev (>= 209~),
               pkg-config,
               procps,
               tzdata
Standards-Version: 3.9.8
Homepage: https://www.docker.com/community-edition
Vcs-Git: https://anonscm.debian.org/git/docker/docker.io.git
Vcs-Browser: https://anonscm.debian.org/cgit/docker/docker.io.git
XS-Go-Import-Path: github.com/docker/docker

Package: docker.io
Architecture: amd64 arm64 armhf i386 ppc64el s390x
Depends: adduser,
         containerd (>= 1.2.6-0ubuntu1~),
         iptables,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: ca-certificates,
            git,
            pigz,
            ubuntu-fan,
            xz-utils,
            ${apparmor:Recommends}
Replaces: docker (<< 1.5~)
Breaks: docker (<< 1.5~)
Suggests: aufs-tools,
          btrfs-progs,
          cgroupfs-mount | cgroup-lite,
          debootstrap,
          docker-doc,
          rinse,
          zfs-fuse | zfsutils
Built-Using: ${libc:Built-Using}, ${misc:Built-Using}
Description: Linux container runtime
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.

Package: vim-syntax-docker
Architecture: all
Depends: vim, ${misc:Depends}
Recommends: vim-addon-manager
Suggests: docker.io
Description: Docker container engine - Vim highlighting syntax files
 This package provides syntax files for the Vim editor for editing Dockerfiles
 from the Docker container engine.

Package: golang-github-docker-docker-dev
Architecture: all
Depends: golang-github-docker-docker-credential-helpers-dev, ${misc:Depends}
Replaces: golang-docker-dev (<< 1.8.2~ds1-1~)
Breaks: golang-docker-dev (<< 1.8.2~ds1-1~)
Provides: golang-docker-dev
Description: Externally reusable Go packages included with Docker
 These packages are intentionally developed by upstream in such a way that they
 are reusable to projects outside Docker and only rely on each other or other
 external dependencies to be built.

Package: golang-docker-dev
Section: oldlibs
Priority: optional
Architecture: all
Depends: golang-github-docker-docker-dev, ${misc:Depends}
Description: Transitional package for golang-github-docker-docker-dev
 This is a transitional package to ease upgrades to the
 golang-github-docker-docker-dev package. It can safely be removed.

Package: docker-doc
Provides: docker.io-doc
Section: doc
Architecture: all
Depends: ${misc:Depends}
Description: Linux container runtime -- documentation
 Docker complements kernel namespacing with a high-level API which operates at
 the process level. It runs unix processes with strong guarantees of isolation
 and repeatability across servers.
 .
 Docker is a great building block for automating distributed systems:
 large-scale web deployments, database clusters, continuous deployment systems,
 private PaaS, service-oriented architectures, etc.
 .
 This package contains the daemon and client. Using docker.io on non-amd64 hosts
 is not supported at this time. Please be careful when using it on anything
 besides amd64.
 .
 Also, note that kernel version 3.8 or above is required for proper operation of
 the daemon process, and that any lower versions may have subtle and/or glaring
 issues.
 .
 This package provides documentation for Docker.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

export VERSION := $(shell cat VERSION)

export DOCKER_GITCOMMIT := $(shell ./debian/helpers/gitcommit.sh $(VERSION))

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# AppArmor can be optionally used in Debian and is there by default in Ubuntu, so we need support for it compiled into our binary
# same story with SELinux
export DOCKER_BUILDTAGS := apparmor seccomp selinux

ifneq (,$(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	NUMJOBS := $(patsubst parallel=%, %, $(filter parallel=%, $(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j '$(NUMJOBS)'
endif

# build explicitly against Go 1.13 (for now):
#   https://github.com/moby/moby/pull/40353
#   https://github.com/containerd/containerd/issues/4509
#   https://github.com/containerd/containerd/pull/4050
#   https://github.com/golang/go/issues/37942
export PATH := /usr/lib/go-1.13/bin:$(PATH)

override_dh_gencontrol:
	# if we're on Ubuntu, we need to Recommends: apparmor
	echo 'apparmor:Recommends=$(shell dpkg-vendor --is Ubuntu && echo apparmor)' >> debian/docker.io.substvars
	echo 'libc:Built-Using=$(shell dpkg-query -f '$${source:Package} (= $${source:Version})' -W libc-dev-bin)' >> debian/docker.io.substvars
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(DOCKER_BUILDTAGS)" \
		github.com/docker/docker/cmd/dockerd \
		github.com/docker/cli/cmd/docker \
		github.com/docker/libnetwork/cmd/proxy \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_configure:
	# set up GOPATH symlink farm
	# libnetwork
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/libnetwork' '$(OUR_GOPATH)/src/github.com/docker/libnetwork'
	# cli
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/components/cli' '$(OUR_GOPATH)/src/github.com/docker/cli'
	# engine
	mkdir -p '$(OUR_GOPATH)/src/github.com/docker'
	ln -sfT '$(CURDIR)/components/engine' '$(OUR_GOPATH)/src/github.com/docker/docker'

_require-gitcommit:
	@bash -c '{ [ "$$DOCKER_GITCOMMIT" ]; } || { echo; echo "error: missing DOCKER_GITCOMMIT - see debian/upstream-version-gitcommits"; echo; exit 2; } >&2'

override_dh_auto_build: _build-tini _build-proxy _build-cli _build-manpages _build-engine
	@#

# several "supporting binaries" need to be built and installed
# (https://github.com/docker/docker-ce/tree/v19.03.6/components/engine/hack/dockerfile/install)

_build-tini: # (docker-init)
	mkdir -p tini/build
	cd tini/build \
		&& cmake .. \
		&& make tini-static

_build-proxy: # (from libnetwork)
	go build -o libnetwork/docker-proxy github.com/docker/libnetwork/cmd/proxy

_build-cli: _require-gitcommit
	DISABLE_WARN_OUTSIDE_CONTAINER=1 \
		make -C components/cli \
			LDFLAGS='' \
			VERSION='$(VERSION)' \
			GITCOMMIT='$(DOCKER_GITCOMMIT)' \
			dynbinary

# https://github.com/docker/docker-ce/blob/v19.03.6/components/cli/scripts/docs/generate-man.sh
# (replacing hard-coded "/tmp/gen-manpages" with "debian/tmp/gen-manpages")
_build-manpages:
	cd '$(OUR_GOPATH)/src/github.com/docker/cli' \
		&& export PATH='$(OUR_GOPATH)/bin':"$$PATH" \
		&& sed 's!/tmp/gen-manpages!$(CURDIR)/debian/tmp/gen-manpages!g' scripts/docs/generate-man.sh \
			| bash

_build-engine: _require-gitcommit
	cd components/engine \
		&& PRODUCT=docker ./hack/make.sh dynbinary

# basic smoke test to ensure binaries built successfully
# (especially since their actual tests are *really* involved)
override_dh_auto_test:
	# tini
	./tini/build/tini-static --version
	# cli
	./components/cli/build/docker --version
	# engine
	./components/engine/bundles/dynbinary-daemon/dockerd --version

override_dh_strip:
	# Go has lots of problems with stripping, so just don't

override_dh_auto_install:
	# we use dh_install / dh-exec for installing files where they need to be

# "--no-start" because we have a debconf prompt to determine whether to restart during upgrades
# (which means we get to handle both "start" and "stop" ourselves too)
override_dh_installinit:
	dh_installinit --name=docker --no-start

override_dh_installudev:
	# use priority z80 to match the upstream priority of 80
	dh_installudev --priority=z80

override_dh_install:
	dh_install
	dh_apparmor --profile-name=docker.io -pdocker.io

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info

override_dh_auto_clean:
	@# stop debhelper from doing "make clean"

%:
	dh $@ --with=bash-completion,systemd
